c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ###########################################################
c     ##                                                       ##
c     ##  subroutine attach1  --  setup of connectivity arrays  ##
c                                 within the box only
c     ##                                                       ##
c     ###########################################################
c
c
c     "attach" generates lists of 1-3, 1-4 and 1-5 connectivities
c     starting from the previously determined list of attached
c     atoms (ie, 1-2 connectivity)
c
c
      subroutine attach1
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'couple.i'
      include 'couple1.i'
      include 'iounit.i'
      include 'cross.i'
      integer i,j,k,m
      integer jj,kk
c
c
c     loop over all atoms finding all the 1-3 relationships;
c     note "n12" and "i12" have already been setup elsewhere
c
      do i = 1, n
       do j =1,n12old(i)
        i121(j,i)=i12(j,i)
       enddo
       n121(i)=n12old(i)
      enddo
      do i = 1, n
         n131(i) = 0
         do j = 1, n121(i)
            jj = i121(j,i)
            do k = 1, n121(jj)
               kk = i121(k,jj)
               if (kk .eq. i)  goto 10
               do m = 1, n121(i)
                  if (kk .eq. i121(m,i))  goto 10
               end do
               n131(i) = n131(i) + 1
               i131(n131(i),i) = kk
   10          continue
            end do
         end do
         if (n131(i) .gt. maxn131) then
            write (iout,20)  i
   20       format (/,' ATTACH  --  Too many 1-3 Connected Atoms',
     &                 ' Attached to Atom',i6)
            call fatal
         end if
         call sort (n131(i),i131(1,i))
      end do
c
c     loop over all atoms finding all the 1-4 relationships
c
      do i = 1, n
         n141(i) = 0
         do j = 1, n131(i)
            jj = i131(j,i)
            do k = 1, n121(jj)
               kk = i121(k,jj)
               if (kk .eq. i)  goto 30
               do m = 1, n121(i)
                  if (kk .eq. i121(m,i))  goto 30
               end do
               do m = 1, n131(i)
                  if (kk .eq. i131(m,i))  goto 30
               end do
               n141(i) = n141(i) + 1
               i141(n141(i),i) = kk
   30          continue
            end do
         end do
         if (n141(i) .gt. maxn141) then
            write (iout,40)  i
   40       format (/,' ATTACH  --  Too many 1-4 Connected Atoms',
     &                 ' Attached to Atom',i6)
            call fatal
         end if
         call sort (n141(i),i141(1,i))
      end do
c
c     loop over all atoms finding all the 1-5 relationships
c
      do i = 1, n
         n151(i) = 0
         do j = 1, n141(i)
            jj = i141(j,i)
            do k = 1, n121(jj)
               kk = i121(k,jj)
               if (kk .eq. i)  goto 50
               do m = 1, n121(i)
                  if (kk .eq. i121(m,i))  goto 50
               end do
               do m = 1, n131(i)
                  if (kk .eq. i131(m,i))  goto 50
               end do
               do m = 1, n141(i)
                  if (kk .eq. i141(m,i))  goto 50
               end do
               n151(i) = n151(i) + 1
               i151(n151(i),i) = kk
   50          continue
            end do
         end do
         if (n151(i) .gt. maxn151) then
            write (iout,60)  i
   60       format (/,' ATTACH  --  Too many 1-5 Connected Atoms',
     &                 ' Attached to Atom',i6)
            call fatal
         end if
         call sort (n151(i),i151(1,i))
      end do
      return
      end
