      subroutine calmolcen
c     precalculate molecular centers for the case of twist
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'molcul.i'
      include 'cross.i'
      include 'atmtyp.i'
      integer i,init,stop,ia,k
      real*8 xmc,ymc,zmc,xmid,ymid,zmid,fa,weight
      common/cmc/xmc(maxatm),ymc(maxatm),zmc(maxatm)

      if(nper.eq.0)return

C$OMP PARALLEL DO PRIVATE(i,xmid,ymid,zmid,init,stop,ia,k,weight,
C$OMP+ fa) DEFAULT(SHARED)
      do 1 i=1,nmol
      xmid=0.0d0
      ymid=0.0d0
      zmid=0.0d0
      init = imol(1,i)
      stop = imol(2,i)
      do 2 ia=init,stop
      k=kmol(ia)
      weight=mass(k)
      xmid=xmid+x(k)*weight
      ymid=ymid+y(k)*weight
2     zmid=zmid+z(k)*weight  
      fa=molmass(i)
      xmc(i)=xmid/fa
      ymc(i)=ymid/fa
1     zmc(i)=zmid/fa

      return
      end

      subroutine calmolceni(i,xmc,ymc,zmc)
c     precalculate molecular centers for the case of twist
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'molcul.i'
      include 'cross.i'
      include 'atmtyp.i'
      integer i,ia,k
      real*8 xmc,ymc,zmc,fa,weight

      xmc=0.0d0
      ymc=0.0d0
      zmc=0.0d0
      do 2 ia=imol(1,i),imol(2,i)
      k=kmol(ia)
      weight=mass(k)
      xmc=xmc+x(k)*weight
      ymc=ymc+y(k)*weight
2     zmc=zmc+z(k)*weight  
      fa=molmass(i)
      xmc=xmc/fa
      ymc=ymc/fa
      zmc=zmc/fa

      return
      end
