c     ncross  number of bonds across box
c     nc1,nc2   associated atoms
c     nper    number of periodic atoms
c     lper    their list
c     cfi     the twist angle
c     icx     the 1D periodic axis
c     cco     the cutoff function parameter
c     irwp    if irwp=0 ... use distance from central molecule
c                     1 ... use distance from cylinder ord radius rwp 
c     rwp...rwp2 radius of the inner and outer cylinder
c     drot    limit for the distance from the front walls
c     lwgr    write gradient each time
c     maxstep0 maximal MD step
c     twm,twp  twisting moments along axis, and integrated values
c     lstay keep the center of the central molecule where it were
c           at the start of MD (otherwise shift it to (0,0,0)
c     lmot stabilize rotation of the central molecule around the
c          twist axis
c     lwall   use harmonic potential to puch molecules
c     from crossing twisted walls
c     fwall is the harmonic constant
c     mhb is number of harmonic barriers (dynamically set during run)
c     ohb is running deviation
c     icen push everything to box at the beginning of minimization
c     lwdad write information about the box crossings
c     iav effective rotation average
c     iwcross write also iwcross-times replicas
c     iav = 0 none
c           1 forward only
c           2 (fa+fb)/2
c           3 weighted by fi
c     xstay,ystay,zstay ... initial position of central molecule
      integer ncross,ncm,nc1,nc2,nper,lper,n12old,icx,irwp,icen,
     1iii,itest,ktest,iwcross
      real*8 cfi,cco,rwp,drot,maxstep0,rwp2,twp,twm,twmi,twpi,
     1xstay,ystay,zstay
      parameter (ncm=100)
      logical lwgr,lwdad,lstay,lmot
      common /crosss/xstay,ystay,zstay,cfi,cco,rwp,drot,rwp2,
     1 ncross,nc1(ncm),nc2(ncm),nper,lper(maxatm),
     1icx,n12old(maxatm),iwcross,irwp,icen,
     1lwdad,iave,lstay,lmot
      common /copt/ lwgr
      common /cmxst/ maxstep0
      common /xtwist/ twp,twm,twpi,twmi
      logical lwall
      real*8 fwall,ohb
      integer ihb,mhb,xhb,iave
      common/cwall/ohb(maxatm),fwall,xhb(maxatm),mhb(maxatm),lwall,ihb
      common /ctest/ iii,itest,ktest
