      subroutine echargelj1(use_charge,use_vdw)
c     optimized and parallel version, charge and LJvdw interaction
      implicit none
      include 'sizes.i'
      include 'atoms.i'
      include 'bound.i'
      include 'cell.i'
      include 'charge.i'
      include 'chgpot.i'
      include 'couple.i'
      include 'deriv.i'
      include 'energi.i'
      include 'group.i'
      include 'inter.i'
      include 'molcul.i'
      include 'shunt.i'
      include 'usage.i'
      include 'virial.i'
      include 'cross.i'
      include 'cfast.i'
      include 'parallel.i'
      include 'vdwpot.i'
      include 'vdw.i'
      include 'boxes.i'
      include 'ctwist.i'
c     
      integer ltype(maxatm),i,ii,ic,j,it,iv,k,itxyz,
     2ix,iy,kt,kv,i3,k3,iv3,kv3,ij,ist
      real*8 time00,time0,time1,time0l,time1l,
     1fi,redi,rediv,xi,yi,zi,xk,yk,zk,xr,yr,zr,sf,cf,
     2r,r2,r3,r4,r5,r6,r7,rb,rb2,fik,e,de,dc,shift,taper,dtaper,
     3trans,dtrans,ev_p(maxproc),ec_p(maxproc),
     4einter_p(maxproc),dedx,dedy,dedz,
     5m_m(maxproc),m_p(maxproc),vir_p(maxproc,3,3),rv,eps,p6,p12,
     6vxx,vyx,vzx,vyy,vzy,vzz,charge(maxatm),redk,redkv,
     7dedix,dediy,dediz,dedkx,dedky,dedkz,p_1,p_2,p_3,p_4,p_5,p_6,
     8p_7,p_8,p_9,p_10,p_11,p_12,p_13,p_14,p_15
      logical lcharge(maxatm),llj(maxatm),use_charge,use_vdw
      integer,allocatable:: iv14(:)
      real*8,allocatable:: cscale(:),vscale(:)
c     integer iv14(maxatm*maxproc)
c     real*8 cscale(maxproc*maxatm),vscale(maxproc*maxatm)
      real*8,allocatable::gc_p(:,:),gv_p(:,:)
      integer nx,ny,nz
      common/creplica/nx,ny,nz
      logical replicc,replicv
      common/creplic/replicc,replicv

      p_1  = 0.5d0*(offc+cutc)
      p_2  = 5.0d0*c5c
      p_3  = 4.0d0*c4c
      p_4  = 3.0d0*c3c
      p_5  = 2.0d0*c2c
      p_6  = 7.0d0*f7c
      p_7  = 6.0d0*f6c
      p_8  = 5.0d0*f5c
      p_9  = 4.0d0*f4c
      p_10 = 3.0d0*f3c
      p_11 = 2.0d0*f2c
      p_12 = 5.0d0*c5v
      p_13 = 4.0d0*c4v
      p_14 = 3.0d0*c3v
      p_15 = 2.0d0*c2v
      allocate(gc_p(nproc,3*n),gv_p(nproc,3*n),
     1cscale(n*nproc),vscale(n*nproc),iv14(n*nproc))
c
C$OMP PARALLEL DO PRIVATE(i,j,ix,iy) DEFAULT(SHARED)
      do 11 i=1,nproc
      ec_p(i)=0.0d0
      m_p(i)=0.0d0
      m_m(i)=0.0d0
      ev_p(i)=0.0d0
      einter_p(i)=0.0d0
      do 111 ix=1,3
      do 111 iy=1,3
111   vir_p(i,ix,iy)=0.0d0
      do 11 j=1,3*n
      gc_p(i,j)=0.0d0
11    gv_p(i,j)=0.0d0
c
c     zero out the charge interaction energy and derivatives
      ec = 0.0d0
      ev = 0.0d0

C$OMP PARALLEL DO PRIVATE(i) DEFAULT(SHARED)
      do 1 i = 1, n
      ltype(i)=0
      lcharge(i) = .false.
      charge(i) = 0.0d0
      llj(i) = .false.
      do 15 j=1,nproc
      cscale(i+n*(j-1)) = 1.0d0
      vscale(i+n*(j-1)) = 1.0d0
15    iv14(i+n*(j-1)) = 0
      dev(1,i) = 0.0d0
      dev(2,i) = 0.0d0
      dev(3,i) = 0.0d0
      dec(1,i) = 0.0d0
      dec(2,i) = 0.0d0
1     dec(3,i) = 0.0d0
c
C$OMP PARALLEL DO PRIVATE(ii,ic) DEFAULT(SHARED)
      do 21 ii=1,nion
      ic=kion(ii)
      charge(ic)=pchg(ii)
21    lcharge(ic)=.true.

C$OMP PARALLEL DO PRIVATE(ii,ic) DEFAULT(SHARED)
      do 12 ii=1,nvdw
      ic=ivdw(ii)
      ltype(ic)=jvdw(ic)
12    llj(ic)=.true.
c
c     iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
C$OMP PARALLEL PRIVATE(ipr,i,it,fi,redi,rediv,iv,j,
C$OMP+ xi,yi,zi,xk,yk,zk,xr,yr,zr,k,itxyz,sf,cf,
C$OMP+ r,r2,r3,r4,r5,r6,r7,rb,rb2,fik,e,de,dc,shift,taper,dtaper,
C$OMP+ trans,dtrans,dedx,dedy,dedz,kt,kv,rv,eps,p6,p12,
C$OMP+ vxx,vyx,vzx,vyy,vzy,vzz,redk,redkv,i3,k3,iv3,kv3,
C$OMP+ dedix,dediy,dediz,dedkx,dedky,dedkz,time0l,time1l)
C$OMP+ DEFAULT(SHARED) 
c     current thread:
      ipr=OMP_GET_THREAD_NUM()+1
      do 101 i=nstart(ipr),nend(ipr)
      if(i.lt.n)then


      it=ltype(i)
      fi=f*charge(i)
      redi=kred(i)
      rediv=1.0d0-redi
      iv=ired(i)
      iv3=3*(iv-1)
      i3=3*(i-1)
c     set interaction scaling coefficients for connected atoms
      do 3 j = 1, n12(i)
      vscale(i12(j,i)+n*(ipr-1)) = v2scale
3     cscale(i12(j,i)+n*(ipr-1)) = c2scale
      do 4 j = 1, n13(i)
      vscale(i13(j,i)+n*(ipr-1)) = v3scale
4     cscale(i13(j,i)+n*(ipr-1)) = c3scale
      do 5 j = 1, n14(i)
      vscale(i14(j,i)+n*(ipr-1)) = v4scale
      iv14(  i14(j,i)+n*(ipr-1))=i
5     cscale(i14(j,i)+n*(ipr-1)) = c4scale
      do 6 j = 1, n15(i)
      vscale(i15(j,i)+n*(ipr-1)) = v5scale
6     cscale(i15(j,i)+n*(ipr-1)) = c5scale
c     kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk
      do 102 k = i+1, n
      xk=x(k)
      yk=y(k)
      zk=z(k)
      xi=x(i)
      yi=y(i)
      zi=z(i)
      xr=xi-xk
      yr=yi-yk
      zr=zi-zk
      itxyz=0
      e=0.0d0


      if(use_bounds)then
       if(nper.ne.0)then
        if(icx.eq.1)then
         call imxx(xr,yr,zr,xcell2,ycell2,zcell2,xcell,ycell,zcell,
     1   itxyz,yi,zi,i,k,argic,argis,sf,cf,yk,zk,nx)
        else
         if(icx.eq.2)then
          call imxx(yr,zr,xr,ycell2,zcell2,xcell2,ycell,zcell,xcell,
     1    itxyz,zi,xi,i,k,argic,argis,sf,cf,zk,xk,ny)
         else
          call imxx(zr,xr,yr,zcell2,xcell2,ycell2,zcell,xcell,ycell,
     1    itxyz,xi,yi,i,k,argic,argis,sf,cf,xk,yk,nz)
         endif
        endif
       else
        call image (xr,yr,zr)   
       endif
      endif
c
      r2 = xr*xr + yr*yr + zr*zr

      if (r2 .le. off2c.or. r2 .le. off2c) then
       k3=3*(k-1)
       r = sqrt(r2)
       if (r2 .gt. cut2v.or.r2 .gt. cut2c) then
        r3 = r2 * r
        r4 = r2 * r2
        r5 = r2 * r3
        r6 = r3 * r3
        r7 = r3 * r4
       endif
      endif

c     Coulomb: CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      if(use_charge)then
      if (lcharge(i).and.lcharge(k).and.r2 .le. off2c) then
       rb = r + ebuffer
       rb2 = rb * rb
       fik = fi * charge(k) * cscale(k+n*(ipr-1))
       e= fik / rb
       de = -fik / rb2
       dc = 0.0d0
       shift = fik / p_1
       e= e- shift
       if (r2 .gt. cut2c) then
        taper  = c5c*r5 + c4c*r4 + c3c*r3 + c2c*r2 + c1c*r + c0c
        dtaper = p_2*r4 + p_3*r3 + p_4*r2 + p_5*r  + c1c
        trans =fik*(f7c*r7+f6c*r6+f5c*r5+f4c*r4
     &  + f3c*r3 + f2c*r2 + f1c*r + f0c)
        dtrans=fik*(p_6*r6+p_7*r5+p_8*r4+p_9*r3+p_10*r2+p_11*r+f1c)
        dc = (e*dtaper + dtrans) / r
        de = de * taper
        e = e*taper + trans
       endif
       de = de / r
       dedx = (de+dc) * xr
       dedy = (de+dc) * yr
       dedz = (de+dc) * zr
   
       ec_p(ipr) = ec_p(ipr) + e
       if (molcule(i) .ne. molcule(k))einter_p(ipr)=einter_p(ipr) + e
       if(itxyz.ge.0)then
c       i or nothing is shifted 
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedix=dedx
        dediy=dedy
        dediz=dedz
       else
c       k is shifted
        dedix=dedx
        dediy=dedy
        dediz=dedz
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
       endif

       gc_p(ipr,k3+1)=gc_p(ipr,k3+1)+ dedkx
       gc_p(ipr,k3+2)=gc_p(ipr,k3+2)+ dedky
       gc_p(ipr,k3+3)=gc_p(ipr,k3+3)+ dedkz
       gc_p(ipr,i3+1)=gc_p(ipr,i3+1)+ dedix
       gc_p(ipr,i3+2)=gc_p(ipr,i3+2)+ dediy
       gc_p(ipr,i3+3)=gc_p(ipr,i3+3)+ dediz
       call incrtwistp(m_p(ipr),m_m(ipr),dedkx,dedky,dedkz,xk,yk,zk,icx)
       call incrtwistp(m_p(ipr),m_m(ipr),dedix,dediy,dediz,xi,yi,zi,icx)
       vxx = xr*dedix
       vyx = yr*dedix
       vzx = zr*dedix
       vyy = yr*dediy
       vzy = zr*dediy
       vzz = zr*dediz
       call incrvirp(maxproc,ipr,vir_p,vxx,vyx,vzx,vyy,vzy,vzz)
      endif
      endif
c     Coulomb  CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


c     LenardJones LCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCL
      if(use_vdw)then
      if (llj(i).and.llj(k).and.r2.le.off2v) then
       kt=ltype(k)
       kv=ired(k)
       kv3=3*(kv-1)
       if (iv14(k+n*(ipr-1)) .eq. i) then
        rv = radmin4(kt,it)
        eps = epsilon4(kt,it)
       else
        rv = radmin(kt,it)
        eps = epsilon(kt,it)
       end if
       eps = eps * vscale(k+n*(ipr-1))
       p6 = (rv/r)**6 
       p12 = p6 * p6
       e = eps * (p12-2.0d0*p6)
       de = eps * (p12-p6) * (-12.0d0/r)
       if (r2 .gt. cut2v) then
        taper = c5v*r5 + c4v*r4 + c3v*r3 + c2v*r2 + c1v*r + c0v
        dtaper = p_12*r4 + p_13*r3 +p_14*r2 + p_15*r + c1v
        de = e *dtaper + de*taper
        e  = e  * taper
       endif
       de   = de / r
       dedx = de * xr
       dedy = de * yr
       dedz = de * zr

       ev_p(ipr) = ev_p(ipr) + e
       if (molcule(i) .ne. molcule(k)) einter_p(ipr) = einter_p(ipr) + e
       if(itxyz.ge.0)then
c       i or nothing is shifted 
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedix=dedx
        dediy=dedy
        dediz=dedz
       else
c       k is shifted
        dedix=dedx
        dediy=dedy
        dediz=dedz
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
       endif
       if (k .eq. kv) then
        gv_p(ipr,k3+1)=gv_p(ipr,k3+1)+ dedkx
        gv_p(ipr,k3+2)=gv_p(ipr,k3+2)+ dedky
        gv_p(ipr,k3+3)=gv_p(ipr,k3+3)+ dedkz
       else
        redk=kred(k)
        redkv=1.0d0-redk
        gv_p(ipr,k3+1)=gv_p(ipr,k3+1)+ dedkx*redk
        gv_p(ipr,k3+2)=gv_p(ipr,k3+2)+ dedky*redk
        gv_p(ipr,k3+3)=gv_p(ipr,k3+3)+ dedkz*redk
        gv_p(ipr,kv3+1)=gv_p(ipr,kv3+1)+ dedkx*redkv
        gv_p(ipr,kv3+2)=gv_p(ipr,kv3+2)+ dedky*redkv
        gv_p(ipr,kv3+3)=gv_p(ipr,kv3+3)+ dedkz*redkv
       endif
       if (i .eq. iv) then
        gv_p(ipr,i3+1)=gv_p(ipr,i3+1)+ dedix
        gv_p(ipr,i3+2)=gv_p(ipr,i3+2)+ dediy
        gv_p(ipr,i3+3)=gv_p(ipr,i3+3)+ dediz
       else
        gv_p(ipr,i3+1)=gv_p(ipr,i3+1)+ dedix*redi
        gv_p(ipr,i3+2)=gv_p(ipr,i3+2)+ dediy*redi
        gv_p(ipr,i3+3)=gv_p(ipr,i3+3)+ dediz*redi
        gv_p(ipr,iv3+1)=gv_p(ipr,iv3+1)+ dedix*rediv
        gv_p(ipr,iv3+2)=gv_p(ipr,iv3+2)+ dediy*rediv
        gv_p(ipr,iv3+3)=gv_p(ipr,iv3+3)+ dediz*rediv
       endif
       call incrtwistp(m_p(ipr),m_m(ipr),dedkx,dedky,dedkz,xk,yk,zk,icx)
       call incrtwistp(m_p(ipr),m_m(ipr),dedix,dediy,dediz,xi,yi,zi,icx)
       vxx = xr * dedix
       vyx = yr * dedix
       vzx = zr * dedix
       vyy = yr * dediy
       vzy = zr * dediy
       vzz = zr * dediz
       call incrvirp(maxproc,ipr,vir_p,vxx,vyx,vzx,vyy,vzy,vzz)
      end if
      end if
c     LenardJones LCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLC

102   continue
c     kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk
c
c     reset interaction scaling coefficients for connected atoms
      do 7 j = 1, n12(i)
      vscale(i12(j,i)+n*(ipr-1)) = 1.0d0
7     cscale(i12(j,i)+n*(ipr-1)) = 1.0d0
      do 8 j = 1, n13(i)
      vscale(i13(j,i)+n*(ipr-1)) = 1.0d0
8     cscale(i13(j,i)+n*(ipr-1)) = 1.0d0
      do 9 j = 1, n14(i)
      vscale(i14(j,i)+n*(ipr-1)) = 1.0d0
9     cscale(i14(j,i)+n*(ipr-1)) = 1.0d0
      do 10 j = 1, n15(i)
      vscale(i15(j,i)+n*(ipr-1)) = 1.0d0
10    cscale(i15(j,i)+n*(ipr-1)) = 1.0d0

      endif
101   continue
C$OMP END PARALLEL
c     iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii

      if (.not. use_replica)  goto 999

c     iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
C$OMP PARALLEL PRIVATE(ipr,i,it,fi,redi,rediv,iv,
C$OMP+ xi,yi,zi,xk,yk,zk,xr,yr,zr,k,itxyz,sf,cf,
C$OMP+ r,r2,r3,r4,r5,r6,r7,rb,rb2,fik,e,de,dc,shift,taper,dtaper,
C$OMP+ trans,dtrans,dedx,dedy,dedz,kt,kv,rv,eps,p6,p12,
C$OMP+ vxx,vyx,vzx,vyy,vzy,vzz,redk,redkv,i3,k3,iv3,kv3,
C$OMP+ dedix,dediy,dediz,dedkx,dedky,dedkz,j,ij,ist)
C$OMP+ DEFAULT(SHARED) 
c     current thread:
      ipr=OMP_GET_THREAD_NUM()+1
      do 201 i=nstart(ipr),nend(ipr)
      it=ltype(i)
      fi=f*charge(i)
      redi=kred(i)
      rediv=1.0d0-redi
      iv=ired(i)
      iv3=3*(iv-1)
      i3=3*(i-1)
c     set interaction scaling coefficients for connected atoms
      do 13 j = 1, n12(i)
      vscale(i12(j,i)+n*(ipr-1)) = v2scale
13    cscale(i12(j,i)+n*(ipr-1)) = c2scale
      do 14 j = 1, n13(i)
      vscale(i13(j,i)+n*(ipr-1)) = v3scale
14    cscale(i13(j,i)+n*(ipr-1)) = c3scale
      do 22 j = 1, n14(i)
      vscale(i14(j,i)+n*(ipr-1)) = v4scale
      iv14(  i14(j,i)+n*(ipr-1))=i
22    cscale(i14(j,i)+n*(ipr-1)) = c4scale
      do 16 j = 1, n15(i)
      vscale(i15(j,i)+n*(ipr-1)) = v5scale
16    cscale(i15(j,i)+n*(ipr-1)) = c5scale
c     kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk
      do 202 k = i, n


      do 202 j=1,ncell
      itxyz=0
      e=0.0d0
      xk=x(k)
      yk=y(k)
      zk=z(k)
      xi=x(i)
      yi=y(i)
      zi=z(i)
      xr=xi-xk
      yr=yi-yk
      zr=zi-zk

      if(use_bounds)then
       if(nper.ne.0)then
        if(icx.eq.1)then
         call imxxr(xr,yr,zr,xbox,ybox,zbox,
     1   xcell,ycell,zcell,xcell2,ycell2,zcell2,
     1   icell(1,j),icell(2,j),icell(3,j),
     1   itxyz,xi,yi,zi,i,k,argic,argis,sf,cf,xk,yk,zk,nx)
         ij=icell(1,j)
        else
         if(icx.eq.2)then
          call imxxr(yr,zr,xr,ybox,zbox,xbox,
     1    ycell,zcell,xcell,ycell2,zcell2,xcell2,
     1    icell(2,j),icell(3,j),icell(1,j),
     1    itxyz,yi,zi,xi,i,k,argic,argis,sf,cf,yk,zk,xk,ny)
          ij=icell(2,j)
         else
          call imxxr(zr,xr,yr,zbox,xbox,ybox,
     1    zcell,xcell,ycell,zcell2,xcell2,ycell2,
     1    icell(3,j),icell(1,j),icell(2,j),
     1    itxyz,zi,xi,yi,i,k,argic,argis,sf,cf,zk,xk,yk,nz)
          ij=icell(3,j)
         endif
        endif
       else
        call imager (xr,yr,zr,j)   
       endif
      endif
c
      r2 = xr*xr + yr*yr + zr*zr

      if (r2 .le. off2c.or. r2 .le. off2c) then
       k3=3*(k-1)
       r = sqrt(r2)
       if (r2 .gt. cut2v.or.r2 .gt. cut2c) then
        r3 = r2 * r
        r4 = r2 * r2
        r5 = r2 * r3
        r6 = r3 * r3
        r7 = r3 * r4
       endif
      endif

c     Coulomb: CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      if(use_charge.and.replicc)then
      if (lcharge(i).and.lcharge(k).and.r2 .le. off2c) then
       rb = r + ebuffer
       rb2 = rb * rb
       fik = fi * charge(k) * cscale(k+n*(ipr-1))
       e= fik / rb
       de = -fik / rb2
       dc = 0.0d0
       shift = fik / p_1
       e= e- shift
       if (r2 .gt. cut2c) then
        taper = c5c*r5 + c4c*r4 + c3c*r3 + c2c*r2 + c1c*r + c0c
        dtaper = p_2*r4 + p_3*r3  + p_4*r2 + p_5*r + c1c
        trans = fik * (f7c*r7 + f6c*r6 + f5c*r5 + f4c*r4
     &  + f3c*r3 + f2c*r2 + f1c*r + f0c)
        dtrans=fik*(p_6*r6+p_7*r5+p_8*r4+p_9*r3+p_10*r2+p_11*r+f1c)
        dc = (e*dtaper + dtrans) / r
        de = de * taper
        e = e*taper + trans
       endif
       de = de / r
       dedx = (de+dc) * xr
       dedy = (de+dc) * yr
       dedz = (de+dc) * zr

       if(i.eq.k)e=e/2.0d0
       ec_p(ipr) = ec_p(ipr) + e
       if (molcule(i) .ne. molcule(k))einter_p(ipr)=einter_p(ipr) + e
c      i is shifted ij - times for replica
       if(itxyz.ge.0)then
c       i or nothing is shifted for image:
c 
c       k is not rotated:
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz

c       total i shift and cos/sin of the angle:
        ist=ij+itxyz
        cf= argic(i+maxatm*(ist-1))
        sf= argis(i+maxatm*(ist-1))

c       i is rotated back:
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedix=dedx
        dediy=dedy
        dediz=dedz
       else
c       k is shifted
c
c       i is rotated just by ij:
        cf= argic(i+maxatm*(ij-1))
        sf= argis(i+maxatm*(ij-1))
        dedix=dedx
        dediy=dedy
        dediz=dedz
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dediy, dediz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dediz, dedix,cf,-sf)
          else
           call trb( dedix, dediy,cf,-sf)
          endif
         endif
        endif
c
c       k is rotated by -itxyz
        cf= argic(k+maxatm*(-itxyz-1))
        sf= argis(k+maxatm*(-itxyz-1))
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
       endif

       gc_p(ipr,k3+1)=gc_p(ipr,k3+1)+ dedkx
       gc_p(ipr,k3+2)=gc_p(ipr,k3+2)+ dedky
       gc_p(ipr,k3+3)=gc_p(ipr,k3+3)+ dedkz
       gc_p(ipr,i3+1)=gc_p(ipr,i3+1)+ dedix
       gc_p(ipr,i3+2)=gc_p(ipr,i3+2)+ dediy
       gc_p(ipr,i3+3)=gc_p(ipr,i3+3)+ dediz
       call incrtwistp(m_p(ipr),m_m(ipr),dedkx,dedky,dedkz,xk,yk,zk,icx)
       call incrtwistp(m_p(ipr),m_m(ipr),dedix,dediy,dediz,xi,yi,zi,icx)
       vxx = xr*dedix
       vyx = yr*dedix
       vzx = zr*dedix
       vyy = yr*dediy
       vzy = zr*dediy
       vzz = zr*dediz
       call incrvirp(maxproc,ipr,vir_p,vxx,vyx,vzx,vyy,vzy,vzz)
      endif
      endif
c     Coulomb  CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


c     LenardJones LCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCL
      if(use_vdw.and.replicv)then
      if (llj(i).and.llj(k).and.r2.le.off2v) then
       kt=ltype(k)
       kv=ired(k)
       kv3=3*(kv-1)
       if (iv14(k+n*(ipr-1)) .eq. i) then
        rv = radmin4(kt,it)
        eps = epsilon4(kt,it)
       else
        rv = radmin(kt,it)
        eps = epsilon(kt,it)
       end if
       eps = eps * vscale(k+n*(ipr-1))
       p6 = (rv/r)**6 
       p12 = p6 * p6
       e = eps * (p12-2.0d0*p6)
       de = eps * (p12-p6) * (-12.0d0/r)
       if (r2 .gt. cut2v) then
        taper = c5v*r5 + c4v*r4 + c3v*r3 + c2v*r2 + c1v*r + c0v
        dtaper = p_12*r4 + p_13*r3 +p_14*r2 + p_15*r + c1v
        de = e *dtaper + de*taper
        e  = e  * taper
       endif
       de   = de / r
       dedx = de * xr
       dedy = de * yr
       dedz = de * zr

       if(i.eq.k)e=e/2.0d0
       ev_p(ipr) = ev_p(ipr) + e
       if (molcule(i) .ne. molcule(k)) einter_p(ipr) = einter_p(ipr) + e
       if(itxyz.ge.0)then
c       i or nothing is shifted:

c       k is not rotated:
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
c
c       total i shift and cos/sin of the angle:
        ist=ij+itxyz
        cf= argic(i+maxatm*(ist-1))
        sf= argis(i+maxatm*(ist-1))

c       i is rotated back:
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedix=dedx
        dediy=dedy
        dediz=dedz
       else
c       k is shifted
c
c       i is rotated just by ij:
        dedix=dedx
        dediy=dedy
        dediz=dedz
        cf= argic(i+maxatm*(ij-1))
        sf= argis(i+maxatm*(ij-1))
        dedix=dedx
        dediy=dedy
        dediz=dedz
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dediy, dediz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dediz, dedix,cf,-sf)
          else
           call trb( dedix, dediy,cf,-sf)
          endif
         endif
        endif
c
c       k is rotated by -itxyz
        cf= argic(k+maxatm*(-itxyz-1))
        sf= argis(k+maxatm*(-itxyz-1))
        if(nper.ne.0.and.itxyz.ne.0)then
         if(icx.eq.1)then
          call trb( dedy, dedz,cf,-sf)
         else
          if(icx.eq.2)then
           call trb( dedz, dedx,cf,-sf)
          else
           call trb( dedx, dedy,cf,-sf)
          endif
         endif
        endif
        dedkx=-dedx
        dedky=-dedy
        dedkz=-dedz
       endif
       if (k .eq. kv) then
        gv_p(ipr,k3+1)=gv_p(ipr,k3+1)+ dedkx
        gv_p(ipr,k3+2)=gv_p(ipr,k3+2)+ dedky
        gv_p(ipr,k3+3)=gv_p(ipr,k3+3)+ dedkz
       else
        redk=kred(k)
        redkv=1.0d0-redk
        gv_p(ipr,k3+1)=gv_p(ipr,k3+1)+ dedkx*redk
        gv_p(ipr,k3+2)=gv_p(ipr,k3+2)+ dedky*redk
        gv_p(ipr,k3+3)=gv_p(ipr,k3+3)+ dedkz*redk
        gv_p(ipr,kv3+1)=gv_p(ipr,kv3+1)+ dedkx*redkv
        gv_p(ipr,kv3+2)=gv_p(ipr,kv3+2)+ dedky*redkv
        gv_p(ipr,kv3+3)=gv_p(ipr,kv3+3)+ dedkz*redkv
       endif
       if (i .eq. iv) then
        gv_p(ipr,i3+1)=gv_p(ipr,i3+1)+ dedix
        gv_p(ipr,i3+2)=gv_p(ipr,i3+2)+ dediy
        gv_p(ipr,i3+3)=gv_p(ipr,i3+3)+ dediz
       else
        gv_p(ipr,i3+1)=gv_p(ipr,i3+1)+ dedix*redi
        gv_p(ipr,i3+2)=gv_p(ipr,i3+2)+ dediy*redi
        gv_p(ipr,i3+3)=gv_p(ipr,i3+3)+ dediz*redi
        gv_p(ipr,iv3+1)=gv_p(ipr,iv3+1)+ dedix*rediv
        gv_p(ipr,iv3+2)=gv_p(ipr,iv3+2)+ dediy*rediv
        gv_p(ipr,iv3+3)=gv_p(ipr,iv3+3)+ dediz*rediv
       endif
       call incrtwistp(m_p(ipr),m_m(ipr),dedkx,dedky,dedkz,xk,yk,zk,icx)
       call incrtwistp(m_p(ipr),m_m(ipr),dedix,dediy,dediz,xi,yi,zi,icx)
       vxx = xr * dedix
       vyx = yr * dedix
       vzx = zr * dedix
       vyy = yr * dediy
       vzy = zr * dediy
       vzz = zr * dediz
       call incrvirp(maxproc,ipr,vir_p,vxx,vyx,vzx,vyy,vzy,vzz)
      end if
      end if
c     LenardJones LCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLCLC

202   continue
c     kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk
c
c     reset interaction scaling coefficients for connected atoms
      do 17 j = 1, n12(i)
      vscale(i12(j,i)+n*(ipr-1)) = 1.0d0
17    cscale(i12(j,i)+n*(ipr-1)) = 1.0d0
      do 18 j = 1, n13(i)
      vscale(i13(j,i)+n*(ipr-1)) = 1.0d0
18    cscale(i13(j,i)+n*(ipr-1)) = 1.0d0
      do 19 j = 1, n14(i)
      vscale(i14(j,i)+n*(ipr-1)) = 1.0d0
19    cscale(i14(j,i)+n*(ipr-1)) = 1.0d0
      do 20 j = 1, n15(i)
      vscale(i15(j,i)+n*(ipr-1)) = 1.0d0
20    cscale(i15(j,i)+n*(ipr-1)) = 1.0d0

201   continue
C$OMP END PARALLEL 
c     iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii
 
999   continue

C$OMP PARALLEL DO PRIVATE(i,i3,ipr) DEFAULT(SHARED)
      do 23 i=1,n
      i3=3*(i-1)
      do 23 ipr=1,nproc
      dec(1,i)=dec(1,i)+gc_p(ipr,i3+1)
      dev(1,i)=dev(1,i)+gv_p(ipr,i3+1)
      dec(2,i)=dec(2,i)+gc_p(ipr,i3+2)
      dev(2,i)=dev(2,i)+gv_p(ipr,i3+2)
      dec(3,i)=dec(3,i)+gc_p(ipr,i3+3)
23    dev(3,i)=dev(3,i)+gv_p(ipr,i3+3)

      do 200 ipr=1,nproc
      vir(1,1)=vir(1,1)+vir_p(ipr,1,1)
      vir(1,2)=vir(1,2)+vir_p(ipr,1,2)
      vir(1,3)=vir(1,3)+vir_p(ipr,1,3)
      vir(2,1)=vir(2,1)+vir_p(ipr,2,1)
      vir(2,2)=vir(2,2)+vir_p(ipr,2,2)
      vir(2,3)=vir(2,3)+vir_p(ipr,2,3)
      vir(3,1)=vir(3,1)+vir_p(ipr,3,1)
      vir(3,2)=vir(3,2)+vir_p(ipr,3,2)
      vir(3,3)=vir(3,3)+vir_p(ipr,3,3)
      twm=twm+m_m(ipr)
      twp=twp+m_p(ipr)
      ev=ev+ev_p(ipr)
200   ec=ec+ec_p(ipr)
c
      return

      end

      subroutine imxx(xr,yr,zr,xbox2,ybox2,zbox2,xbox,ybox,zbox,
     1itx,yi,zi,i,k,argic,argis,sf,cf,yk,zk,nx)
      implicit none
      integer itx,i,k,nx
      real*8 xr,yr,zr,xbox2,ybox2,zbox2,xbox,ybox,zbox,
     1yi,zi,argic(*),argis(*),sf,cf,yk,zk
      include 'sizes.i'

      if(xr.gt.xbox2)then
       xr=xr-xbox
       itx=itx-nx
c      shift k
       cf= argic(k+maxatm*(nx-1))
       sf= argis(k+maxatm*(nx-1))
       call trb(yk,zk,cf,sf)
      else
       if(xr.lt.-xbox2)then
        xr=xr+xbox
        itx=itx+nx
c       shift i 
        cf=argic(i+maxatm*(nx-1))
        sf=argis(i+maxatm*(nx-1))
        call trb(yi,zi,cf,sf)
       else
        goto 1
       endif
      endif
      yr=yi-yk
      zr=zi-zk

1     if(yr.gt.ybox2)then
       yr=yr-ybox
      else
       if(yr.lt.-ybox2)then
        yr=yr+ybox
       endif
      endif

      if(zr.gt.zbox2)then
       zr=zr-zbox
      else
       if(zr.lt.-zbox2)then
        zr=zr+zbox
       endif
      endif

      return

      end

      subroutine setfastcuts
      implicit none
      include 'cfast.i'
      include 'chgpot.i'
      include 'cutoff.i'
      include 'bound.i'
      real*8 denom,term
      logical replicc,replicv
      common/creplic/replicc,replicv
      call replica(chgcut)
      replicc=use_replica
      call replica(0.0d0)
      call replica(vdwcut)
      replicv=use_replica
      f = electric / dielec
      offc=chgcut
      cutc=chgtaper
      off2c= offc * offc
      off3c= off2c* offc
      off4c= off2c* off2c
      off5c= off2c* off3c
      off6c= off3c* off3c
      off7c= off3c* off4c
      cut2c= cutc* cutc
      cut3c= cut2c* cutc
      cut4c= cut2c* cut2c
      cut5c= cut2c* cut3c
      cut6c= cut3c* cut3c
      cut6c= cut3c* cut3c
      cut7c= cut3c* cut4c
      c0c= 0.0d0
      c1c= 0.0d0
      c2c= 0.0d0
      c3c= 0.0d0
      c4c= 0.0d0
      c5c= 0.0d0
      f0c= 0.0d0
      f1c= 0.0d0
      f2c= 0.0d0
      f3c= 0.0d0
      f4c= 0.0d0
      f5c= 0.0d0
      f6c= 0.0d0
      f7c= 0.0d0
      if (cutc .lt. offc) then
       denom = (offc-cutc)**5
       c0c = offc*off2c * (off2c-5.0d0*offc*cutc+10.0d0*cut2c) / denom
       c1c = -30.0d0 * off2c*cut2c / denom
       c2c = 30.0d0 * (off2c*cutc+offc*cut2c) / denom
       c3c = -10.0d0 * (off2c+4.0d0*offc*cutc+cut2c) / denom
       c4c = 15.0d0 * (offc+cutc) / denom
       c5c = -6.0d0 / denom
      end if
      if (cutc.lt.offc) then
       term = 9.3d0 * cutc*offc / (offc-cutc)
       denom = cut7c - 7.0d0*cut6c*offc + 21.0d0*cut5c*off2c
     &              - 35.0d0*cut4c*off3c + 35.0d0*cut3c*off4c
     &              - 21.0d0*cut2c*off5c + 7.0d0*cutc*off6c - off7c
       denom = term * denom
       f0c = cut3c*off3c * (-39.0d0*cutc+64.0d0*offc) / denom
       f1c = cut2c*off2c
     & * (117.0d0*cut2c-100.0d0*cutc*offc-192.0d0*off2c)/denom
       f2c = cutc*offc * (-117.0d0*cut3c-84.0d0*cut2c*offc
     & +534.0d0*cutc*off2c+192.0d0*off3c) / denom
       f3c = (39.0d0*cut4c+212.0d0*cut3c*offc-450.0d0*cut2c*off2c
     & -612.0d0*cutc*off3c-64.0d0*off4c) / denom
       f4c = (-92.0d0*cut3c+66.0d0*cut2c*offc
     & +684.0d0*cutc*off2c+217.0d0*off3c) / denom
       f5c= (42.0d0*cut2c-300.0d0*cutc*offc-267.0d0*off2c) / denom
       f6c= (36.0d0*cutc+139.0d0*offc) / denom
       f7c= -25.0d0 / denom
      end if

c     VdW cuts etc:
      offv=vdwcut
      cutv=vdwtaper
      off2v= offv * offv
      off3v= off2v* offv
      off4v= off2v* off2v
      off5v= off2v* off3v
      off6v= off3v* off3v
      off7v= off3v* off4v
      cut2v= cutv* cutv
      cut3v= cut2v* cutv
      cut4v= cut2v* cut2v
      cut5v= cut2v* cut3v
      cut6v= cut3v* cut3v
      cut6v= cut3v* cut3v
      cut7v= cut3v* cut4v
      c0v= 0.0d0
      c1v= 0.0d0
      c2v= 0.0d0
      c3v= 0.0d0
      c4v= 0.0d0
      c5v= 0.0d0
      f0v= 0.0d0
      f1v= 0.0d0
      f2v= 0.0d0
      f3v= 0.0d0
      f4v= 0.0d0
      f5v= 0.0d0
      f6v= 0.0d0
      f7v= 0.0d0
      if (cutv .lt. offv) then
       denom = (offv-cutv)**5
       c0v = offv*off2v * (off2v-5.0d0*offv*cutv+10.0d0*cut2v) / denom
       c1v = -30.0d0 * off2v*cut2v / denom
       c2v = 30.0d0 * (off2v*cutv+offv*cut2v) / denom
       c3v = -10.0d0 * (off2v+4.0d0*offv*cutv+cut2v) / denom
       c4v = 15.0d0 * (offv+cutv) / denom
       c5v = -6.0d0 / denom
      end if
      return
      end

      subroutine incrtwistp(m_p,m_m,fx,fy,fz,x,y,z,icx)
      implicit none
      integer icx
      real*8 m_p,fx,fy,fz,x,y,z,m_m,m
      if(icx.eq.1) m=y*fz-z*fy       
      if(icx.eq.2) m=z*fx-x*fz       
      if(icx.eq.3) m=x*fy-y*fx       
      if(m.lt.0.0d0)then
       m_m=m_m+m
      else
       m_p=m_p+m
      endif
      return
      end

      subroutine incrvirp(maxproc,ipr,vir,vxx,vyx,vzx,vyy,vzy,vzz)
      implicit none
      integer ipr,maxproc
      real*8 vir(maxproc,3,3),vxx,vyx,vzx,vyy,vzy,vzz
      vir(ipr,1,1) = vir(ipr,1,1) + vxx
      vir(ipr,2,1) = vir(ipr,2,1) + vyx
      vir(ipr,3,1) = vir(ipr,3,1) + vzx
      vir(ipr,1,2) = vir(ipr,1,2) + vyx
      vir(ipr,2,2) = vir(ipr,2,2) + vyy
      vir(ipr,3,2) = vir(ipr,3,2) + vzy
      vir(ipr,1,3) = vir(ipr,1,3) + vzx
      vir(ipr,2,3) = vir(ipr,2,3) + vzy
      vir(ipr,3,3) = vir(ipr,3,3) + vzz
      return
      end

      subroutine imxxr(xr,yr,zr,xbox,ybox,zbox,
     1xcell,ycell,zcell,xcell2,ycell2,zcell2,
     1icex,icey,icez,
     1itx,xi,yi,zi,i,k,argic,argis,sf,cf,xk,yk,zk,nx)
      implicit none
      integer itx,i,k,nx,icex,icey,icez
      real*8 xr,yr,zr,xbox,ybox,zbox,xi,
     1yi,zi,argic(*),argis(*),sf,cf,xk,yk,zk,
     1xcell,ycell,zcell,xcell2,ycell2,zcell2
      include 'sizes.i'

      xi = xi +  icex * xbox
      cf=argic(i+maxatm*(icex-1))
      sf=argis(i+maxatm*(icex-1))
      call trb(yi,zi,cf,sf)

      yi = yi +  icey * ybox
      zi = zi +  icez * zbox 
      xr=xi-xk
      yr=yi-yk
      zr=zi-zk
c
      if(xr.gt.xcell2)then
       xr=xr-xcell
       itx=itx-nx
c      shift k
       cf= argic(k+maxatm*(nx-1))
       sf= argis(k+maxatm*(nx-1))
       call trb(yk,zk,cf,sf)
      else
       if(xr.lt.-xcell2)then
        xr=xr+xcell
        itx=itx+nx
c       shift i 
        cf=argic(i+maxatm*(nx-1))
        sf=argis(i+maxatm*(nx-1))
        call trb(yi,zi,cf,sf)
       else
        goto 1
       endif
      endif
      yr=yi-yk
      zr=zi-zk

1     if(yr.gt.ycell2)then
       yr=yr-ycell
      else
       if(yr.lt.-ycell2)then
        yr=yr+ycell
       endif
      endif

      if(zr.gt.zcell2)then
       zr=zr-zcell
      else
       if(zr.lt.-zcell2)then
        zr=zr+zcell
       endif
      endif

      return

      end
