      subroutine imagerp(xr,yr,zr,i,ia,x1,y1,z1,ib,x2,y2,z2)
      implicit none
      include 'sizes.i'
      include 'boxes.i'
      include 'cell.i'
      include 'cross.i'
      include 'rotc.i'
      integer i,ia,ib
      real*8 xr,yr,zr,x1(*),y1(*),z1(*),x2(*),y2(*),z2(*),xsize,ysize,
     1zsize,xaa,yaa,zaa,xsize2,ysize2,zsize2,xmove,pi,arg,
     2ymove,zmove
c
c
c     set dimensions for either single box or replicated cell
c
      pi=4.0d0*atan(1.0d0)
      if (i .ge. 0) then
         xsize = xcell
         ysize = ycell
         zsize = zcell
         xsize2 = xcell2
         ysize2 = ycell2
         zsize2 = zcell2
      else
         xsize = xbox
         ysize = ybox
         zsize = zbox
         xsize2 = xbox2
         ysize2 = ybox2
         zsize2 = zbox2
      end if
c
c     compute the distance to translate along each cell axis
c
      if (i .le. 0) then
         xmove = 0.0d0
         ymove = 0.0d0
         zmove = 0.0d0
      else
         xmove = icell(1,i) * xbox
         ymove = icell(2,i) * ybox
         zmove = icell(3,i) * zbox
      end if

      if (.not.orthogonal) then
       write(6,*)' Only orthogonal allowed for 1D periodicity'
       call fatal
      endif

      xr = x1(ia) - x2(ib)
      yr = y1(ia) - y2(ib)
      zr = z1(ia) - z2(ib)
      xaa=x1(ia)
      yaa=y1(ia)
      zaa=z1(ia)
c
      itx=0
      ity=0
      itz=0

    
      if(icx.eq.1)then
c      x just shift:
       xr  = xr  + xmove
       xaa = xaa + xmove
c      y and z rotate and shift:
       call rott(irwp,rwp,icell(1,i),ia,nper,lper,xsize,ysize,
     1 zsize,x1,y1,z1,
     1 yaa,ysize2,zaa,zsize2,cco,yr,zr,y2(ib),z2(ib),cfi,icx,ib)
c      if this is too much, go back:
    
       call itit(itx,xr,xaa,xsize2,xsize)
       call rott(irwp,rwp,itx,ia,nper,lper,xsize,ysize,zsize,x1,y1,z1,
     1 yaa,ysize2,zaa,zsize2,cco,yr,zr,y2(ib),z2(ib),
     1 cfi*xsize/xbox,icx,ib)
       yr  = yr  + ymove
       yaa = yaa + ymove
       zr  = zr  + zmove
       zaa = zaa + zmove
       itx=itx*nint(xsize/xbox)+icell(1,i)
       arg=cfi*pi/180.0d0*dble(itx)
       ucos=cos(arg)
       usin=sin(arg)
       call itit(ity,yr,yaa,ysize2,ysize)
       call itit(itz,zr,zaa,zsize2,zsize)
       ity=ity*nint(ysize/ybox)+icell(2,i)
       itz=itz*nint(zsize/zbox)+icell(3,i)
      endif

      if(icx.eq.2)then
       yr  = yr  + ymove
       yaa = yaa + ymove
       call rott(irwp,rwp,icell(2,i),ia,nper,lper,xsize,ysize,zsize,
     1 x1,y1,z1,
     1 zaa,zsize2,xaa,xsize2,cco,zr,xr,z2(ib),x2(ib),cfi,icx,ib)
       call itit(ity,yr,yaa,ysize2,ysize)
       call rott(irwp,rwp,ity,ia,nper,lper,xsize,ysize,zsize,x1,y1,z1,
     1 zaa,zsize2,xaa,xsize2,cco,zr,xr,z2(ib),x2(ib),cfi*ysize/ybox,
     1 icx,ib)
       xr  = xr  + xmove
       xaa = xaa + xmove
       zr  = zr  + zmove
       zaa = zaa + zmove
       ity=ity*nint(ysize/ybox)+icell(2,i)
       arg=cfi*pi/180.0d0*dble(ity)
       ucos=cos(arg)
       usin=sin(arg)
       call itit(itz,zr,zaa,zsize2,zsize)
       call itit(itx,xr,xaa,xsize2,xsize)
       itz=itz*nint(zsize/zbox)+icell(3,i)
       itx=itx*nint(xsize/xbox)+icell(1,i)
      endif

      if(icx.eq.3)then
       zr  = zr  + zmove
       zaa = zaa + zmove
       call rott(irwp,rwp,icell(3,i),ia,nper,lper,xsize,ysize,zsize,
     1 x1,y1,z1,
     1 xaa,xsize2,yaa,ysize2,cco,xr,yr,x2(ib),y2(ib),cfi,icx,ib)
       call itit(itz,zr,zaa,zsize2,zsize)
       call rott(irwp,rwp,itz,ia,nper,lper,xsize,ysize,zsize,x1,y1,z1,
     1 xaa,xsize2,yaa,ysize2,cco,xr,yr,x2(ib),y2(ib),cfi*zsize/zbox,
     1 icx,ib)
       xr  = xr  + xmove
       xaa = xaa + xmove
       yr  = yr  + ymove
       yaa = yaa + ymove
       itz=itz*nint(zsize/zbox)+icell(3,i)
       arg=cfi*pi/180.0d0*dble(itz)
       ucos=cos(arg)
       usin=sin(arg)
       call itit(itx,xr,xaa,xsize2,xsize)
       call itit(ity,yr,yaa,ysize2,ysize)
       itx=itx*nint(xsize/xbox)+icell(1,i)
       ity=ity*nint(ysize/ybox)+icell(2,i)
      endif

c
      return
      end
