      subroutine imaget(xr,yr,zr,ia,cf,sf,itx,ity,itz,
     1xi,yi,zi,xk,yk,zk)
      implicit none
      include 'sizes.i'
      include 'boxes.i'
      include 'cross.i'
      real*8 xr,yr,zr,cf,sf,xi,yi,zi,xk,yk,zk
      integer ia,itx,ity,itz
c
      cf=1.0d0
      sf=0.0d0
      itx=0
      ity=0
      itz=0
      if(icx.eq.1)then
       call ititt(itx,xr,xbox2,xbox)
       if(itx.ne.0)then
        call rot2(itx,ia,nper,lper,xbox,ybox,zbox,cfi,sf,cf,yi,zi)
        yr=yi-yk
        zr=zi-zk
       endif
       call ititt(ity,yr,ybox2,ybox)
       call ititt(itz,zr,zbox2,zbox)
      else
       if(icx.eq.2)then
        call ititt(ity,yr,ybox2,ybox)
        if(ity.ne.0)then
         call rot2(ity,ia,nper,lper,xbox,ybox,zbox,cfi,sf,cf,zi,xi)
         zr=zi-zk
         xr=xi-xk
        endif
        call ititt(itz,zr,zbox2,zbox)
        call ititt(itx,xr,xbox2,xbox)
       else
        if(icx.eq.3)then
         call ititt(itz,zr,zbox2,zbox)
         if(itz.ne.0)then
          call rot2(itz,ia,nper,lper,xbox,ybox,zbox,cfi,sf,cf,xi,yi)
          xr=xi-xk
          yr=yi-yk
         endif
         call ititt(itx,xr,xbox2,xbox)
         call ititt(ity,yr,ybox2,ybox)
        endif
       endif
      endif
      return
      end

      subroutine ititt(itx,xr,xbox2,xbox)
      implicit none
      integer itx
      real*8 xr,xbox2,xbox
      itx=0
      do while (abs(xr) .gt. xbox2)
       if(xr.gt.0.0d0)then
        itx= itx - 1
        xr = xr  - xbox
       else
        itx= itx + 1
        xr = xr  + xbox
       endif
      end do
      return 
      end

      subroutine rot2(it,ia,nper,lper,xbox,ybox,zbox,
     1cfi,sf,cf,yr,zr)
      implicit none
      include 'sizes.i'
      include 'atmolc.i'
      include 'atoms.i'
      include 'ctwist.i'
      integer it,ia,nper,lper(*)
      real*8 xbox,ybox,f,zbox,cfi,sf,cf,arg,yr,zr
      common/carg/arg,f
c     damping factor:
      f=ffarg(ia)
c     total angle (including damping factor):
      arg=aaarg(ia)*dble(it)
      if(abs(it).gt.2)then
       sf=sin(arg)
       cf=cos(arg)
      else
       sf=argis(ia)*dble(it)
       cf=argic(ia)
      endif
      call trb(yr,zr,cf,sf)
      return
      end
      
      subroutine trb(y,z,cf,sf)
      implicit none
      real*8 y,z,yy,sf,cf
      yy= y*cf+z*sf
      z =-y*sf+z*cf
      y=yy
      return
      end

      subroutine trbb(yy,zz,y,z,cf,sf)
      implicit none
      real*8 y,z,yy,sf,cf,zz
      yy= y*cf+z*sf
      zz=-y*sf+z*cf
      return
      end

      subroutine ass12(xia,xa,yia,ya,zia,za,
     1                 xib,xb,yib,yb,zib,zb,
     2                 xic,xc,yic,yc,zic,zc,
     3                 xid,xd,yid,yd,zid,zd)
      implicit none
      real*8 xia,xa,yia,ya,zia,za,xib,xb,yib,yb,zib,zb,
     2       xic,xc,yic,yc,zic,zc,xid,xd,yid,yd,zid,zd
      xia = xa
      yia = ya
      zia = za
      xib = xb
      yib = yb
      zib = zb
      xic = xc
      yic = yc
      zic = zc
      xid = xd
      yid = yd
      zid = zd
      return
      end

      subroutine ass3(xia,xa,yia,ya,zia,za)
      implicit none
      real*8 xia,xa,yia,ya,zia,za
      xia = xa
      yia = ya
      zia = za
      return
      end

      subroutine imagef(xr,yr,zr,cf,sf,itx,ity,itz,
     1xi,yi,zi,xk,yk,zk)
c     as imaget, but rotation supplied
      implicit none
      include 'sizes.i'
      include 'cell.i'
      include 'cross.i'
      real*8 xr,yr,zr,cf,sf,xi,yi,zi,xk,yk,zk
      integer itx,ity,itz
c
      if(icx.eq.1)then
       call ititt(itx,xr,xcell2,xcell)
       if(itx.ne.0)then
        call trb(yi,zi,cf,sf)
        yr=yi-yk
        zr=zi-zk
       endif
       call ititt(ity,yr,ycell2,ycell)
       call ititt(itz,zr,zcell2,zcell)
      else
       if(icx.eq.2)then
        call ititt(ity,yr,ycell2,ycell)
        if(ity.ne.0)then
         call trb(zi,xi,cf,sf)
         zr=zi-zk
         xr=xi-xk
        endif
        call ititt(itz,zr,zcell2,zcell)
        call ititt(itx,xr,xcell2,xcell)
       else
        if(icx.eq.3)then
         call ititt(itz,zr,zcell2,zcell)
         if(itz.ne.0)then
          call trb(xi,yi,cf,sf)
          yr=yi-yk
          zr=zi-zk
         endif
         call ititt(itx,xr,xcell2,xcell)
         call ititt(ity,yr,ycell2,ycell)
        endif
       endif
      endif
      return
      end

      function farg(ia,f)
      implicit none
      include 'sizes.i'
      include 'atmolc.i'
      include 'atoms.i'
      include 'cross.i'
      include 'cell.i'
      integer ia,j
      real*8 f,farg,findda
c
c     is ia part of the central molecule?:
      do 1 j=1,nper
      if(lper(j).eq.ia)then
c      then full rotation:
       f=1.0d0
       farg=cfi*4.0d0*atan(1.0d0)/180.0d0
       return
      endif
1     continue

c     is not central molecule, damped rotation:
      f=findda(.false.,iamol,x,y,z,xcell,ycell,zcell,ia,moat)
      farg=f*cfi*4.0d0*atan(1.0d0)/180.0d0
      return
      end
