c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ##############################################################
c     ##                                                          ##
c     ##  subroutine prtxyzc --  output of Cartesian coordinates  ##
c     ##                                                          ##
c     ##############################################################
c
c
c     "prtxyz" writes out a set of Cartesian coordinates
c     to an external disk file, for twisted structures
c     twice the periodic box
c
c
      subroutine prtxyzc(ixyz)
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'couple.i'
      include 'files.i'
      include 'inform.i'
      include 'titles.i'
      include 'cross.i'
      include 'boxes.i'
      include 'rotc.i'
      integer i,k,ixyz,i2,ir,itot,irstart,kk
      integer size,crdsiz,i12tem(maxval),ntem
      real*8 crdmin,crdmax,ydumm,zdumm,xr,yr,zr,xr2,yr2,zr2
      logical opened
      character*2 atmc
      character*2 crdc
      character*2 digc
      character*25 fstr
      character*120 xyzfile
c
c
c     open the output unit if not already done
c
      inquire (unit=ixyz,opened=opened)
      if (.not. opened) then
         xyzfile = filename(1:leng)//'.xyz.c'
         call version (xyzfile,'new')
         open (unit=ixyz,file=xyzfile,status='new')
      end if
c
c     check for large systems needing extended formatting
c
      atmc = 'i6'
      if (n .ge. 100000)  atmc = 'i7'
      if (n .ge. 1000000)  atmc = 'i8'
      crdmin = 0.0d0
      crdmax = 0.0d0
      do 4 i = 1, n
      crdmin = min(crdmin,x(i),y(i),z(i))
4     crdmax = max(crdmax,x(i),y(i),z(i))
      crdsiz = 6
      if (crdmin .le. -1000.0d0)  crdsiz = 7
      if (crdmax .ge. 10000.0d0)  crdsiz = 7
      if (crdmin .le. -10000.0d0)  crdsiz = 8
      if (crdmax .ge. 100000.0d0)  crdsiz = 8
      crdsiz = crdsiz + max(6,digits)
      size = 0
      call numeral (crdsiz,crdc,size)
      if (digits .le. 6) then
         digc = '6 '
      else if (digits .le. 8) then
         digc = '8'
      else
         digc = '10'
      end if
c 
c     replicas:
      if(iwcross.lt.0)then
       irstart=iwcross
      else
       irstart=0
      endif
c
c     write out the number of atoms and the title
      if (ltitle .eq. 0) then
         fstr = '('//atmc//')'
         write (ixyz,fstr(1:4))  n*(abs(iwcross)-irstart+1)
      else
         fstr = '('//atmc//',2x,a)'
         write (ixyz,fstr(1:9))  n*2,title(1:ltitle)
      end if
c
c     write out the coordinate line for each atom
      fstr = '('//atmc//',2x,a3,3f'//crdc//
     &          '.'//digc//',i6,8'//atmc//')'
c
      itot=0
c     cycle over all replicas:
      do 1 ir=irstart,abs(iwcross)
      itot=itot+1
c     cycle over original atoms:
      do 1 i = 1, n
      xr=x(i)
      yr=y(i)
      zr=z(i)
c     rotate ir-times forward
      if(icx.eq.1)then
       call rott(irwp,rwp,ir,i,nper,lper,xbox,ybox,zbox,x,y,z,
     1 yr,ybox2,zr,zbox2,cco,ydumm,zdumm,0.0d0,0.0d0,cfi,icx,i) 
       xr=xr+xbox*dble(ir)
      else
       if(icx.eq.2)then
        call rott(irwp,rwp,ir,i,nper,lper,xbox,ybox,zbox,x,y,z,
     1  zr,zbox2,xr,xbox2,cco,ydumm,zdumm,0.0d0,0.0d0,cfi,icx,i) 
        yr=yr+ybox*dble(ir)
       else
        call rott(irwp,rwp,ir,i,nper,lper,xbox,ybox,zbox,x,y,z,
     1  xr,xbox2,yr,ybox2,cco,ydumm,zdumm,0.0d0,0.0d0,cfi,icx,i) 
        zr=zr+zbox*dble(ir)
       endif
      endif
      ntem=n12old(i)
      do 2 k=1,ntem
2     i12tem(k)=i12(k,i)+n*(itot-1)
c
c     is i part of a cross-bond? i2 .. the other atom:
      i2=0
      do 3 k=1,ncross
      if(i.eq.nc1(k))i2=nc2(k)
3     if(i.eq.nc2(k))i2=nc1(k)
c
c     delete it from this replica
      if(i2.ne.0)then
       do 5 k=1,ntem
       if(i12tem(k).eq.i2+n*(itot-1))then
        do 51 kk=k,ntem-1
51      i12tem(kk)=i12tem(kk+1)
        ntem=ntem-1
        goto 555
       endif
5      continue
      endif

c     draw it to the previous replica
555   if(i2.ne.0.and.itot.gt.1)then
       if(icx.eq.1.and.x(i).gt.x(i2))i2=0
       if(icx.eq.2.and.y(i).gt.y(i2))i2=0
       if(icx.eq.3.and.z(i).gt.z(i2))i2=0
       if(i2.ne.0)then
        ntem=ntem+1
        i12tem(ntem)=i2+(itot-2)*n
       endif
      endif

c     draw it to the next replica
      if(i2.ne.0.and.itot.lt.abs(iwcross)-irstart+1)then
       if(icx.eq.1.and.x(i).lt.x(i2))i2=0
       if(icx.eq.2.and.y(i).lt.y(i2))i2=0
       if(icx.eq.3.and.z(i).lt.z(i2))i2=0
       if(i2.ne.0)then
        ntem=ntem+1
        i12tem(ntem)=i2+itot*n
       endif
      endif
1     write (ixyz,fstr)(itot-1)*n+i,name(i),xr,yr,zr,type(i),
     1(i12tem(k),k=1,ntem)
c
c     close the output unit if opened by this routine
      if (.not. opened)  close (unit=ixyz)

      return
      end
