      subroutine rota(it,ia,nper,lper,xcell,ycell,zcell,
     1 x1,y1,z1,yc,zc,yrc,zrc,y2,z2,cfi,ib,xa,xb,xc2)
      implicit none
      include 'rotc.i'
      include 'sizes.i'
      include 'atmolc.i'
      integer it,ia,j,nper,lper(*),ib
      logical lcyl,lcylb
      real*8 x1(*),y1(*),z1(*),xcell,ycell,zcell,yc,zc,
     1yrc,zrc,y2,z2,pi,cfi,arg,findda,fa,fb,xa,xb,
     1rit,rr,xc2,cd,aa
      real*8 xmc,ymc,zmc
      common/cmc/xmc(maxatm),ymc(maxatm),zmc(maxatm)
c
c     find rotation factors for a,b:
c     is ia part of the central molecule:?
      lcyl=.false.
      do 1 j=1,nper
      lcyl=lper(j).eq.ia
1     if(lcyl)goto 5
5     continue
c
c     is ib part of the central molecule:?
      lcylb=.false.
      do 7 j=1,nper
      lcylb=lper(j).eq.ib
7     if(lcylb)goto 8
8     continue
c
      pi=4.0d0*atan(1.0d0)
      if(it.ne.0)then
c      find damping functions for ia and ib:
       fa =findda(lcyl ,iamol,x1,y1,z1,xcell,ycell,zcell,ia,moat)
       fb =findda(lcylb,iamol,x1,y1,z1,xcell,ycell,zcell,ib,moat)
       rr=dble(it)*0.5d0*(fa+fb)
      else
       if(dabs(xb).gt.dabs(xa))then
        cd=xb
       else
        cd=xa
       endif
c      extent of rotation (rit=+1 left, rit=-1 right):
       if(cd.gt.0.0d0)then
        rit=max(     -cd/xc2,-1.0d0)
       else
        rit=min( dabs(cd)/xc2,1.0d0)
       endif
c      relative rotation of a(aa=1) or b(aa=-1):
       rr=rit*(fa-fb)
      endif

      arg=cfi*pi/180.0d0*rr
      call tra(arg,yc,zc)
      yrc=yc-y2
      zrc=zc-z2

      return
      end
      
      function findda(lcyl,iamol,x1,y1,z1,xcell,ycell,zcell,ia,moat)
      implicit none
      logical lcyl
      include 'sizes.i'
      include 'cross.i'
      integer iamol,j,ia,moat(*),jj
      real*8 findda,xce,yce,zce,x1(*),y1(*),z1(*),dd,dist,dw,
     1xcell,ycell,zcell,x2l,y2l,z2l,fcco,fdist
      real*8 xmc,ymc,zmc
      common/cmc/xmc(maxatm),ymc(maxatm),zmc(maxatm)

      if(lcyl)then
       findda=1.0d0
      else
       if(iamol.ne.0)then
c       distance of molecule containing ia
        xce=xmc(moat(ia))
        yce=ymc(moat(ia))
        zce=zmc(moat(ia))
       else
c       distance of atom ia
        xce=x1(ia)
        yce=y1(ia)
        zce=z1(ia)
       endif
       dist=fdist(irwp,rwp,nper,xce,yce,zce,lper,x1,y1,z1,icx)
       dw=0.0d0
       x2l=xcell/2.0d0
       y2l=ycell/2.0d0
       z2l=zcell/2.0d0
       if(icx.eq.1) call dww(dw,yce,y2l,zce,z2l)
       if(icx.eq.2) call dww(dw,zce,z2l,xce,x2l)
       if(icx.eq.3) call dww(dw,xce,x2l,yce,y2l)
c      damping function from the central cylinder/molecule:
       findda=fcco(dist,cco,dist+dw)
c      if(ia.eq.415)write(6,*)dist,cco,dw
      endif

      return
      end

      subroutine tra(arg,y,z)
      implicit none
      real*8 y,z,yy,sf,cf,arg
      common/tratrm/sf,cf
      sf=dsin(arg)
      cf=dcos(arg)
      yy= y*cf+z*sf
      z =-y*sf+z*cf
      y=yy
      return
      end

      subroutine trm(y,z)
      implicit none
      real*8 y,z,yy,sf,cf
      common/tratrm/sf,cf
      yy= y*cf-z*sf
      z = y*sf+z*cf
      y=yy
      return
      end
