      subroutine rott(irwp,rwp,it,ia,nper,lper,xcell,ycell,zcell,
     1 x1,y1,z1,yc,ycl2,zc,zcl2,cco,yrc,zrc,y2,z2,cfi,icx,ib)
      implicit none
      include 'rotc.i'
      include 'sizes.i'
      include 'atmolc.i'
      include 'molcul.i'
      integer it,ia,j,nper,lper(*),irwp,icx,ib
      logical lcyl,lcylb
      real*8 x1(*),y1(*),z1(*),xcell,ycell,zcell,yc,zc,ycl2,zcl2,cco,
     1yrc,zrc,y2,z2,pi,cfi,arg,rwp,finddf,dw,ga,gb,fa,fb,fab
c
      if(it.ne.0)then

c      is ia part of the central molecule:?
       lcyl=.false.
       do 1 j=1,nper
       lcyl=lper(j).eq.ia
1      if(lcyl)goto 5
5      continue
c
c      is ib part of the central molecule:?
       lcylb=.false.
       do 7 j=1,nper
       lcylb=lper(j).eq.ib
7      if(lcylb)goto 8
8      continue
c
c      find damping functions for ia and ib:
c      the applied damping is the average:
       dw=0.0d0
       ga=0.0d0
       gb=0.0d0
       fa =finddf(lcyl ,iamol,x1,y1,z1,
     1 xcell,ycell,zcell,ia,moat,dw,ga,it)
       fb =finddf(lcylb,iamol,x1,y1,z1,
     1 xcell,ycell,zcell,ib,moat,dw,gb,it)
       fab=0.5d0*(fa+fb)
c
c      for atoms close to front windows,bias it to fa:
       f=fab
c      f=fab*(1.0d0-ga)+fa*ga
c      f=fab*(1.0d0-ga)*(1.0d0-gb)+fa*ga+fb*gb
c      
c      damped rotation aroung 1D axis:
       pi=4.0d0*atan(1.0d0)
       arg=cfi*pi/180.0d0*dble(it)
       ucos=cos(arg)
       usin=sin(arg)
       call tro(f,ucos,usin,yc,zc)
       yrc=yc-y2
       zrc=zc-z2
      endif
      return
      end
      
      function finddf(lcyl,iamol,x1,y1,z1,
     1xcell,ycell,zcell,ia,moat,dw,ga,it)
      implicit none
      logical lcyl
      include 'sizes.i'
      include 'cross.i'
      include 'atmtyp.i'
      include 'molcul.i'
      integer iamol,i,j,
     1ia,moat(*),jj,it,k
      real*8 finddf,xce,yce,zce,x1(*),y1(*),z1(*),dd,dist,dw,
     1xcell,ycell,zcell,x2l,y2l,z2l,fcco,fac,ga,dfr,rr,weight

      if(iamol.ne.0)then
c      rotate ia only as much as its molecule:
c      find molecular center:
       xce=0.0d0
       yce=0.0d0
       zce=0.0d0
       i=moat(ia)
       do 4 j=imol(1,i),imol(2,i)
       k=kmol(j)
       weight=mass(k)
       xce=xce+x1(k)*weight
       yce=yce+y1(k)*weight
4      zce=zce+z1(k)*weight
       fac=molmass(i)
       xce=xce/fac
       yce=yce/fac
       zce=zce/fac
      else
       xce=x1(ia)
       yce=y1(ia)
       zce=z1(ia)
      endif
      x2l=xcell/2.0d0
      y2l=ycell/2.0d0
      z2l=zcell/2.0d0

c     damping function from the central cylinder/molecule:
      if(lcyl)then
       finddf=1.0d0
      else
       dist=1.0d6
       if(irwp.eq.0)then
c       get distance from central molecule
        do 6 j=1,nper
        jj=lper(j)
        dd=(xce-x1(jj))**2+(yce-y1(jj))**2+(zce-z1(jj))**2
6       if(dd.lt.dist)dist=dd
        dist=dsqrt(dist)
       else
c       from cylinder
        if(icx.eq.1)dist=max(dsqrt(yce**2+zce**2)-rwp,0.0d0)
        if(icx.eq.2)dist=max(dsqrt(zce**2+xce**2)-rwp,0.0d0)
        if(icx.eq.3)dist=max(dsqrt(xce**2+yce**2)-rwp,0.0d0)
       endif
c      dw : find distance from the box walls:
       dw=1.0d6
       if(icx.eq.1) call dww(dw,yce,y2l,zce,z2l)
       if(icx.eq.2) call dww(dw,zce,z2l,xce,x2l)
       if(icx.eq.3) call dww(dw,xce,x2l,yce,y2l)
       finddf=fcco(dist,cco,dist+dw)
      endif

c     dfr: distance from the front walls:
      if(icx.eq.1)then
       rr=xce+dble(it)*xcell
       dfr=min(dabs(rr-x2l),dabs(rr+x2l))
      endif
      if(icx.eq.2)then
       rr=yce+dble(it)*ycell
       dfr=min(dabs(rr-y2l),dabs(rr+y2l))
      endif
      if(icx.eq.3)then
       rr=zce+dble(it)*zcell
       dfr=min(dabs(rr-z2l),dabs(rr+z2l))
      endif
c     damping function from the front walls:
      if(dfr.gt.drot)dfr=drot
      ga=fcco(dfr,cco,drot)

      return
      end
