c
c     "rtwist" reads parameters for a twisted box
c
c
      subroutine rtwist
      implicit none
      include 'sizes.i'
      include 'keys.i'
      include 'cross.i'
      include 'iounit.i'
      include 'couple.i'
      include 'atoms.i'
      include 'atmolc.i'
      include 'cfast.i'
      integer i,j,next,nmin,nmax,icx0,ic,ia,ib
      real*8 xm,ym,zm,pi
      character*20 keyword
      character*120 record,string
      character*1 xyz(3)
      real*8 A(3),P(3),E0(3),sx,sy,sz,SSE0E0,SSPP,AD,SSAE0,SSPE0,
     1XX(3),YY(3),SSXXXX,SSYYYY,SSXXYY,APX,APY,APZ,SSE0AP,
     1SIGN,CB,CA,BANGLE,ANGLE
      integer*4 KK
      data xyz/'x','y','z'/
c
c     preinitialize:
      iave=1
      ncross=0
      iwcross=0
      pi=4.0d0*datan(1.0d0)
      cfi=0.0d0
      cco=0.4d0
      icx0=0
      irwp=0
      rwp=0.0d0
      rwp2=0.0d0
      iii=0
      itest=0
      ktest=0
      iamol=1
      drot=4.0
      lwgr=.false.
      maxstep0=100.0d0
      twm=0.0d0
      twp=0.0d0
      twpi=0.0d0
      twmi=0.0d0
      lwall=.true.
      fwall=10.0d0
      ihb=0
      icen=0
      lwdad=.false.
      lstay=.true.
      lmot=.true.
      nproc=1

      do 1 i = 1, nkey
      next = 1
      record = keyline(i)
      call gettext (record,keyword,next)
      call upcase (keyword)
      string = record(next:120)
      write(6,*)record
      
      if (keyword(1:6) .eq. 'NCROSS') then
       read (string,*,err=1,end=1)  ncross
       if(ncross.gt.ncm)then
        write(iout,30)
30      format(/,' too many cross-box bonds')
        call fatal
       endif
       read (string,*,err=1,end=1)ncross,(nc1(j),nc2(j),j=1,ncross)
      endif

      if (keyword(1:9) .eq. 'NPERIODIC') then
       read (string,*,err=1,end=1)nmin,nmax
       nper=nmax-nmin+1
       if(nper.gt.maxatm)then
        write(iout,40)
40      format(/,' too many nperiodic atoms ')
        call fatal
       endif
       do 2 j=nmin,nmax
2      lper(j-nmin+1)=j
      endif 

      if (keyword(1:5) .eq. 'PERFI')read(string,*,err=1,end=1)cfi

      if (keyword(1:5) .eq. 'PERCO')read(string,*,err=1,end=1)cco

      if (keyword(1:5) .eq. 'IWCRO')read(string,*,err=1,end=1)iwcross

      if (keyword(1:3) .eq. 'RWP')read(string,*,err=1,end=1)rwp

      if (keyword(1:3) .eq. 'RW2')read(string,*,err=1,end=1)rwp2

      if (keyword(1:3) .eq. 'III')read(string,*,err=1,end=1)iii

      if (keyword(1:4) .eq. 'ITES')read(string,*,err=1,end=1)itest

      if (keyword(1:4) .eq. 'KTES')read(string,*,err=1,end=1)ktest

      if (keyword(1:4) .eq. 'IAVE')read(string,*,err=1,end=1)iave

      if (keyword(1:4) .eq. 'IRWP')read(string,*,err=1,end=1)irwp

      if (keyword(1:3) .eq. 'ICX')read(string,*,err=1,end=1)icx0

      if (keyword(1:5) .eq. 'ATMOL')read(string,*,err=1,end=1)iamol

      if (keyword(1:4) .eq. 'LWAL')read(string,*,err=1,end=1)lwall

      if (keyword(1:4) .eq. 'FWAL')read(string,*,err=1,end=1)fwall

      if (keyword(1:4) .eq. 'LWDA')read(string,*,err=1,end=1)lwdad

      if (keyword(1:4) .eq. 'LSTA')read(string,*,err=1,end=1)lstay

      if (keyword(1:4) .eq. 'LMOT')read(string,*,err=1,end=1)lmot

      if (keyword(1:4) .eq. 'LWGR')read(string,*,err=1,end=1)lwgr

      if (keyword(1:4) .eq. 'MXST')read(string,*,err=1,end=1)maxstep0

      if (keyword(1:4) .eq. 'CENT')read(string,*,err=1,end=1)icen

      if (keyword(1:4) .eq. '#PRO')read(string,*,err=1,end=1)nproc


1     continue
c
      write(6,600)icx0,cfi,cco,iwcross,irwp,rwp,rwp2,iave,
     1iamol,lwall,fwall,lwdad,lstay,lmot,
     1iii,itest,ktest,lwgr,maxstep0,icen,
     2nproc
600   format(/,' Twist parameters',/,/,
     1         ' iaxis       ICX   ',i12,/,
     1         ' twist (deg) PERFI ',f12.2,/,
     1         ' cco         PERCO ',f12.2,/,
     1         '             IWCRO ',i12,/,
     1         '             IRWP  ',i12,/,
     1         ' R inner     RWP   ',f12.2,/,
     1         ' R outer     RWP2  ',f12.2,/,
     1         ' iave twist aver.  ',i12,/,
     1         ' iamol       ATMOL ',i12,/,
     1         ' lwall       LWAL  ',l12,/,
     1         ' fwall       FWAL  ',f12.2,/,
     1         '             LWDA  ',l12,/,
     1         ' lstay       LSTAY ',l12,/,
     1         ' lmot        LMOT  ',l12,/,
     1         ' debug atom  III   ',i12,/,
     1         ' debug atom  ITES  ',i12,/,
     1         ' debug atom  KTES  ',i12,/,
     1         ' write grad  LWGR  ',l12,/,
     1         ' max step    MXST  ',f12.6,/,
     1         '             ICEN  ',i12,/,
     1         ' nproc       #PROC ',i12)

c     add the bonds to the bond list
      do 3 i=1,n
3     n12old(i)=n12(i)

      do 4 i=1,ncross
c
c     if the bond nc1 ... nc2 is there, do not add it:
      do 31 ia=1,n
      do 31 ib=1,n12(ia)
31    if(i12(ib,ia).eq.nc1(i).and.ia.eq.nc2(i).or.
     1   i12(ib,ia).eq.nc2(i).and.ia.eq.nc1(i))goto 4

      n12(nc1(i))=n12(nc1(i))+1
      i12(n12(nc1(i)),nc1(i))=nc2(i)
      n12(nc2(i))=n12(nc2(i))+1
      i12(n12(nc2(i)),nc2(i))=nc1(i)
4     continue
c
c     find out which is the 1D periodic axis:
      xm=0.0d0
      ym=0.0d0
      zm=0.0d0
      do 5 i=1,ncross
      if(dabs(x(nc1(i))-x(nc2(i))).gt.xm)xm=dabs(x(nc1(i))-x(nc2(i)))
      if(dabs(y(nc1(i))-y(nc2(i))).gt.ym)ym=dabs(y(nc1(i))-y(nc2(i)))
5     if(dabs(z(nc1(i))-z(nc2(i))).gt.zm)zm=dabs(z(nc1(i))-z(nc2(i)))
      icx=1
      if(ym.gt.xm.and.ym.gt.zm)icx=2
      if(zm.gt.xm.and.zm.gt.ym)icx=3
      if(ncross.gt.0)write(iout,50)xyz(icx)
50    format(' 1D periodic axis found: ',a1)
      if(icx0.ne.0)then
       icx=icx0
       write(iout,51)xyz(icx)
51     format(' changed to ',a1,' according to the key file')
      endif
c
c     find out approximate rotations
      if(ncross.gt.0)write(iout,60)
60    format(' Approximate twist estimated from end atoms:')
      do 6 i=1,ncross
      if(icx.eq.1)then
       sx=1.0d0
       sy=0.0d0
       sz=0.0d0
      endif
      if(icx.eq.2)then
       sx=0.0d0
       sy=1.0d0
       sz=0.0d0
      endif
      if(icx.eq.3)then
       sx=0.0d0
       sy=0.0d0
       sz=1.0d0
      endif
      A(1)=  X(nc2(i))-X(nc2(i))*sx
      A(2)=  Y(nc2(i))-Y(nc2(i))*sy
      A(3)=  Z(nc2(i))-Z(nc2(i))*sz
      P(1)=  X(nc1(i))-X(nc1(i))*sx
      P(2)=  Y(nc1(i))-Y(nc1(i))*sy
      P(3)=  Z(nc1(i))-Z(nc1(i))*sz
      E0(1)=(X(nc1(i))-X(nc2(i)))*sx
      E0(2)=(Y(nc1(i))-Y(nc2(i)))*sy
      E0(3)=(Z(nc1(i))-Z(nc2(i)))*sz
      SSE0E0=E0(1)*E0(1)+E0(2)*E0(2)+E0(3)*E0(3)
      DO 8 KK=1,3
8     E0(KK)=E0(KK)/DSQRT(SSE0E0)
      SSPP=P(1)*P(1)+P(2)*P(2)+P(3)*P(3)
      AD=DSQRT(SSPP)
      SSAE0=A(1)*E0(1)+A(2)*E0(2)+A(3)*E0(3)
      SSPE0=P(1)*E0(1)+P(2)*E0(2)+P(3)*E0(3)
      DO 9 KK=1,3
      XX(KK)=A(KK)-E0(KK)*SSAE0
9     YY(KK)=P(KK)-E0(KK)*SSPE0
      SSXXXX=XX(1)*XX(1)+XX(2)*XX(2)+XX(3)*XX(3)
      SSYYYY=YY(1)*YY(1)+YY(2)*YY(2)+YY(3)*YY(3)
      SSXXYY=XX(1)*YY(1)+XX(2)*YY(2)+XX(3)*YY(3)
      APX=XX(2)*YY(3)-XX(3)*YY(2)
      APY=XX(3)*YY(1)-XX(1)*YY(3)
      APZ=XX(1)*YY(2)-XX(2)*YY(1)
      SSE0AP=APX*E0(1)+APY*E0(2)+APZ*E0(3)
      SIGN=1.0D0
      IF (SSE0AP.NE.0.0D0)SIGN=-SSE0AP/ABS(SSE0AP)
      CB=0.0D0
      IF (AD.NE.0.0D0)CB=-SSPE0/AD
      CA=0.0D0
      IF (SSXXXX.NE.0.0D0.AND.SSYYYY.NE.0.0D0)
     1CA=-SSXXYY/DSQRT(SSXXXX)/DSQRT(SSYYYY)
      BANGLE=0.0D0
      ANGLE=0.0D0
      IF (CB.EQ.-1.0D0)BANGLE=PI
      IF (ABS(CB).LT.1.0D0)BANGLE=ACOS(CB)
      IF (CA.LE.-1.0D0) ANGLE=PI
      IF (ABS(CA).LT.1.0D0) ANGLE=ACOS(CA)
      ANGLE=180.0D0* ANGLE/PI
      BANGLE=180.0D0*BANGLE/PI
      ANGLE=SIGN*ANGLE
      if(ANGLE.lt.-180.0d0)ANGLE=360.0d0+ANGLE
c     torsion, distance, band angle
6     WRITE(iout,322)i,ANGLE,AD
322   format(i5,f15.2,'deg (dist. ',f12.3,' A)')
c
      return
      end
